program triangle;

{$mode objfpc}{$H+}
{$APPTYPE CONSOLE}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  SysUtils, Interfaces, Dialogs, Forms,
  uMainForm, Vulkan, uvkuDescriptorPool, uvkuDescriptorPoolFactory, uvkuDescriptorSet, uvkuSemaphore;

{$R *.res}

var
  heaptrcFile: String;

begin
  if not InitializeVulkan then begin
    MessageDlg('Error', 'unable to initialize vulkan api', mtError, [mbOK], 0);
    halt;
  end;

  heaptrcFile := ChangeFileExt(Application.ExeName, '.heaptrc');
  if (FileExists(heaptrcFile)) then
    DeleteFile(heaptrcFile);
  SetHeapTraceOutput(heaptrcFile);

  RequireDerivedFormResource := True;
  Application.Initialize;
  Application.CreateForm(TMainForm, MainForm);
  Application.Run;
end.

